module Weaver
  module Core
    # Represents a Weaver +artifact+ model element.
    #
    # Author:: Fabio Oliveira
    class Artifact < Base
      # Weaver Symbol which acts as the internal id of the artifact.
      attr_accessor :id
      
      # \Symbol indicating if the artifact resides locally (:local) or in the Weaver service (:service).
      attr_accessor :location
      
      # \String representing the source path to the artifact.
      attr_accessor :source_path
      
      # \String representing the target path to the artifact.
      attr_accessor :target_path
      
      # \Boolean indicating whether or not the artifact is executable.
      attr_accessor :exec
      
      # \String that tells .weaver source file and line number containing this Artifact's definition.
      attr_accessor :weaver_origin
      
      # * +id+ Symbol to represent the entity
      # * +parent+ The enclosing Base
      def initialize(id, parent)
        super(id, parent)
        @type = :artifact
      end
      
      def target()
        return @target_path
      end
      
      def source()
        return @source_path
      end
    end
  end
end