module Weaver
  module Core
    
    # The Cloud class describes cloud parameters for an infrastructure {Topology} and its {Node}s
    class Cloud
      
      # An identifier for the cloud (Symbol, e.g., <code>:ibm_sce</code>, <code>:ibm_scp</code>, <code>:amazon_ec2</code>)
      attr_accessor :type
      
      # The base URL for accessing the cloud and it's API 
      attr_accessor :url
      
      # References a particular image in the cloud 
      attr_accessor :image 
      
      # A description for the cloud. 
      attr_accessor :description 
      
      # A version identifier for a particular cloud. Useful if cloud evolves and topologies
      # cannot only be provisioned on a particular version.
      attr_accessor :version 
      
      # * +type+ An identifier for the cloud (Symbol, e.g., <code>:ibm_sce</code>, <code>:ibm_scp</code>, <code>:amazon_ec2</code>)
      def initialize(type)
        @type = type
      end

    end
    
  end
end