require 'weaver/core/logging'
require 'weaver/core/base'
require 'weaver/core/import_container_mixin'
require 'weaver/core/node_container_mixin'
require 'weaver/service/propagation_checker'

module Weaver
  module Core
    # A Weaver Import which can contain any entities that may be imported/refined into other entities
    # 
    # Author:: Ed Snible
    # Copyright:: IBM
    class Import < Base
      # Validation messages appear sorted in roughly the mixin include order, so important problems that can trigger others, 
      # like import failure, should be placed higher in this list.
      include ImportContainerMixin
      include ComponentContainerMixin
      include NodeContainerMixin
      include AutomationContainer
      include ServiceContainerMixin
      include TopologyContainerMixin
      include LoadDriverContainerMixin
      include PolicyContainerMixin
      
      # Creates a new Import object.
      def initialize(id, parent_scope)
        super(id, parent_scope)
        @type = :import
      end
      
    end
  end
end