require 'weaver/core/logging'
require 'weaver/dsl/requires/type_handler'

module Weaver
  module Dsl
    module Requires
      # Parses Weaver <code>requires :port</code> expressions, such as
      #  requires :port => 8080

      class PortTypeHandler < TypeHandler

        def initialize()
          super [ :port, :ports ]
        end

        def handle(parent, args)
          @@logger.debug "#{self.class} #{parent} #{args}"
          if args.values[0].kind_of?(Array)
            return EmptyIntersectionRequirement.new(parent.model, args)
          else
            return NonmemberRequirement.new(parent.model, args)
          end 
        end

      end
    end
  end
end