module Weaver
  module Coordination
    module Logging
      
      # copied from Weaver::Core::Logging

      @@logger = Logger.new(STDOUT)
      @@logger.level = Logger::DEBUG
      @@logger.formatter = proc do |severity, datetime, progname, msg|
        thread = Thread.current[:name]
        "#{severity} [#{datetime}], #{thread.nil? ? 'default' : thread} --: #{msg}\n"
      end
      
      # Provides Logging for Weaver using Ruby's +Logger+.
        def self.level(log_level)
          @@logger.level = log_level  
        end
        
        def self.get_level 
          @@logger.level
        end
        
        def self.logger=(logger)
          @@logger = logger
        end
        
    end # end module Logging
  end # end module Coordination
end # end module Weaver
